local UnitName = UnitName
local GetTime = GetTime
local UnitCastingInfo = UnitCastingInfo
local UnitChannelInfo = UnitChannelInfo

function oUF:UNIT_SPELLCAST_START(event, unit, spell, spellrank)
	if self.unit ~= unit then return end
	if not self.SpellcastStart then 
		local name, rank, text, texture, startTime, endTime = UnitCastingInfo(unit)
		if not name then return end
			
		self.startTime = startTime / 1000
		self.maxValue = endTime / 1000
		self.delay = 0
		
		self.Castbar:SetMinMaxValues(1, 100)
		self.Castbar:SetValue(1)
		self.Castbar.text:SetText(text)
		self.Castbar:SetAlpha(1)
		self.Castbar.icon:SetTexture(texture)
		self.Castbar.icon:Show()
		self.Castbar:Show()
		self.casting = true
		if unit == "target" then self.unitName = UnitName(unit) end	
	else
		self:SpellcastStart(event, unit, spell, spellrank) 
	end
end

function oUF:UNIT_SPELLCAST_FAILED(event, unit, spellname, spellrank)
	if self.unit ~= unit then return end
	if not self.SpellcastFailed then 
		self.Castbar:SetValue(1)
		self.Castbar.text:SetText()
		self.Castbar.icon:Hide()
		self.Castbar:Hide()
		self.casting = nil
	else
		self:SpellcastFailed(event, unit, spellname, spellrank) 
	end
end

function oUF:UNIT_SPELLCAST_INTERRUPTED(event, unit, spellname, spellrank)
	if self.unit ~= unit then return end
	if not self.SpellcastInterrupted then 
		self.Castbar:SetValue(1)
		self.Castbar.text:SetText()
		self.Castbar.icon:Hide()
		self.Castbar:Hide()
		self.casting = nil	
	else
		self:SpellcastInterrupted(event, unit, spellname, spellrank) 
	end
end
	
function oUF:UNIT_SPELLCAST_DELAYED(event, unit, spellname, spellrank)
	if self.unit ~= unit then return end
	if not self.SpellcastDelayed then 
		local name, rank, text, texture, startTime, endTime = UnitCastingInfo(unit)
		if not startTime then return end
		
		local oldStart = self.startTime
		self.startTime = startTime / 1000
		self.maxValue = endTime / 1000
		self.delay = self.delay + (self.startTime - oldStart)
	else
		self:SpellcastDelayed(event, unit, spellname, spellrank) 
	end
end

function oUF:UNIT_SPELLCAST_CHANNEL_START(event, unit, spellname, spellrank)
	if self.unit ~= unit then return end
	if not self.SpellcastChannelStart then 
		local name, rank, text, texture, startTime, endTime, isTradeSkill = UnitChannelInfo(unit)
		self.startTime = startTime / 1000
		self.endTime = endTime / 1000
		self.duration = self.endTime - self.startTime
		self.maxValue = self.startTime
		self.delay = 0
		self.Castbar:SetMinMaxValues(self.startTime, self.endTime)
		self.Castbar:SetValue(self.endTime)
		self.Castbar.text:SetText(spellname)
		self.Castbar.icon:SetTexture(texture)
		self.Castbar.icon:Show()
		self.Castbar:Show()
		self.channeling = true
		if unit == "target" then self.unitName = UnitName(unit) end
	else
		self:SpellcastChannelStart(event, unit, spellname, spellrank) 
	end
end

function oUF:UNIT_SPELLCAST_CHANNEL_UPDATE(event, unit, spellname, spellrank)
	if self.unit ~= unit then return end
	if not self.SpellcastChannelUpdate then 
		local spell, _, _, _, startTime, endTime, oldStart = UnitChannelInfo(unit);
		local oldStart = self.startTime
		self.startTime = startTime / 1000
		self.endTime = endTime / 1000
		self.maxValue = self.startTime
		self.delay = self.delay + (oldStart - self.startTime)
	else
		self:SpellcastChannelUpdate(event, unit, spellname, spellrank) 
	end
end

function oUF:UNIT_SPELLCAST_CHANNEL_STOP(event, unit, spellname, spellrank)
	if self.unit ~= unit then return end
	if not self.SpellcastChannelStop then 
		self.Castbar:SetValue(1)
		self.Castbar.text:SetText()
		self.Castbar.icon:Hide()
		self.Castbar:Hide()
		self.channeling = nil
	else
		self:SpellcastChannelStop(event, unit, spellname, spellrank) 
	end
end

function oUF:UNIT_SPELLCAST_SUCCEEDED(event, unit, spellname, spellrank)
	if self.unit ~= unit then return end
	if self.SpellcastSucceeded then self:SpellcastSucceeded(event, unit, spellname, spellrank) end
end

function oUF:OnUpdate(elapsed)
	self.timeSinceLastUpdate = self.timeSinceLastUpdate + elapsed 	
	if self.timeSinceLastUpdate > 0.05 then
		if not self.Update then 
			if self.unitName and self.unitName ~= UnitName(self.unit) then
				self.casting = nil
				self.channeling = nil
				self.Castbar:SetValue(1)
				self.Castbar.icon:Hide()
				self.Castbar:Hide()
				self.Castbar.text:SetText()
			end
			if self.casting then
				local status = GetTime()
				if (status > self.maxValue) then
					status = self.maxValue
				end	
				if (status ==  self.maxValue) then
					self.casting = nil
					self.Castbar.icon:Hide()
					self.Castbar:Hide()
					self.Castbar.text:SetText()
					return
				end
				self.Castbar:SetValue( ((status - self.startTime) / (self.maxValue - self.startTime)) * 100 )		
			elseif self.channeling then
				local status = GetTime()
				if ( status > self.endTime ) then
					status = self.endTime
				end
				if ( status == self.endTime ) then
					self.channeling = nil
					self.castbar.icon:Hide()
					self.Castbar:Hide()
					self.Castbar.text:SetText()
					return
				end
				self.Castbar:SetValue( self.startTime + (self.endTime - status) )
			end
			if self.Castbar.delay then
				if self.delay ~= 0 then
					self.Castbar.delay:SetText(self.delay)
				else
					self.Castbar.delay:SetText()
				end
			end
		else
			self:Update(elapsed) 
		end
		self.timeSinceLastUpdate = 0;
	end
end

local callback = function(object)
	if not object.Castbar or not object.Castbar.text or not object.Castbar.icon or object.unit:match"%wtarget$" then return end	
	object:RegisterEvent"UNIT_SPELLCAST_START"
	object:RegisterEvent"UNIT_SPELLCAST_FAILED"
	object:RegisterEvent"UNIT_SPELLCAST_INTERRUPTED"
	object:RegisterEvent"UNIT_SPELLCAST_DELAYED"
	object:RegisterEvent"UNIT_SPELLCAST_CHANNEL_START"
	object:RegisterEvent"UNIT_SPELLCAST_CHANNEL_UPDATE"
	object:RegisterEvent"UNIT_SPELLCAST_CHANNEL_STOP"
	object:RegisterEvent"UNIT_SPELLCAST_SUCCEEDED"
	object:SetScript("OnUpdate", oUF.OnUpdate)
	object.timeSinceLastUpdate = 0
	if object.unit == "player" then
		CastingBarFrame:UnregisterAllEvents()
		CastingBarFrame.Show = function() end
		CastingBarFrame:Hide()
	end
end

oUF:RegisterInitCallback(callback)